<?php
/**
 * Model object generated by: Skipper (http://www.skipper18.com)
 * Do not modify this file manually.
 */

namespace App\AbstractModels;

use Illuminate\Database\Eloquent\Model;

abstract class AbstractDemand extends Model
{
    /**  
     * Primary key type.
     * 
     * @var string
     */
    protected $keyType = 'bigInteger';
    
    /**  
     * The attributes that should be cast to native types.
     * 
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'file_number' => 'string',
        'name_physician' => 'string',
        'patient_id' => 'integer',
        'insurance_id' => 'integer',
        'status' => 'string',
        'updated_at' => 'datetime',
        'created_at' => 'datetime',
        'order_number_physician' => 'integer',
        'qualification_physician' => 'string',
        'hospital' => 'string',
        'qualification_id' => 'integer'
    ];
    
    /**  
     * The guarded property should contain an array of attributes that you do not want to be mass assignable.
     * 
     * @var array
     */
    protected $guarded = [];
    
    public function patient()
    {
        return $this->belongsTo('\App\Patient', 'patient_id', 'id');
    }
    
    public function insurance()
    {
        return $this->belongsTo('\App\Insurance', 'insurance_id', 'id');
    }
    
    
    public function qualification()
    {
        return $this->belongsTo('\App\Qualification', 'qualification_id', 'id');
    }
    
    public function tests()
    {
        return $this->belongsToMany('\App\Exam','tests')->withPivot('resultat_id', 'resultat_type', 'id', 'created_at', 'updated_at','price','insurance_id');
    }

    public function test()
    {
        return $this->hasMany('\App\Test');
    }
}
